org.eclipse.cdt.core.index.export

## Class ExternalExportProjectProvider

- java.lang.Object
- - org.eclipse.cdt.core.index.export.AbstractExportProjectProvider
  - - org.eclipse.cdt.core.index.export.ExternalExportProjectProvider

All Implemented Interfaces:
  IExportProjectProvider

    public class ExternalExportProjectProvider
    extends AbstractExportProjectProvider

An IExportProjectProvider suitable for indexing an external folder. The arguments understood by this provider are

- -source what will become the root of the indexed content
- -include any preinclude files to configure the parser with
- -id the id to write to the produce fragment

### Field Summary

Fields
`static String` `OPT_EXCLUDE`
`static String` `OPT_FRAGMENT_ID`
`static String` `OPT_INCLUDE`
`static String` `OPT_SOURCE`

### Fields inherited from class org.eclipse.cdt.core.index.export.AbstractExportProjectProvider

`NPM`

### Constructor Summary

Constructors
Constructor and Description
`ExternalExportProjectProvider()`

### Method Summary

All Methods Instance Methods Concrete Methods
`ICProject` `createProject()` Creates, configures and returns a project for the indexer to index.
`protected List<IPathEntry>` `getAdditionalRawEntries()` Get additional raw entries (above those added as part of the ExternalExportProjectProvider functionality)
`protected org.eclipse.core.resources.IFolder` `getContentFolder()` Returns the project folder the external content is stored in
`Map<String,String>` `getExportProperties()` Get a String to String map of properties to store with the index content.
`IIndexLocationConverter` `getLocationConverter(ICProject cproject)` The location converter to use on export.

### Methods inherited from class org.eclipse.cdt.core.index.export.AbstractExportProjectProvider

`fail, getApplicationArguments, getParameters, getParameters, getParsedArgs, getSingleString, isPresent, setApplicationArguments`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

### Field Detail

#### OPT_SOURCE

    public static final String OPT_SOURCE

See Also:
  Constant Field Values

#### OPT_INCLUDE

    public static final String OPT_INCLUDE

See Also:
  Constant Field Values

#### OPT_EXCLUDE

    public static final String OPT_EXCLUDE

Since:
  5.7
See Also:
  Constant Field Values

#### OPT_FRAGMENT_ID

    public static final String OPT_FRAGMENT_ID

See Also:
  Constant Field Values

### Constructor Detail

#### ExternalExportProjectProvider

    public ExternalExportProjectProvider()

### Method Detail

#### createProject

    public ICProject createProject()
                            throws org.eclipse.core.runtime.CoreException

Description copied from interface: `IExportProjectProvider`
Creates, configures and returns a project for the indexer to index. This routine should not itself index the project, as a reindex will be performed by the framework. May not return null.

Throws:
  `org.eclipse.core.runtime.CoreException`

#### getContentFolder

    protected org.eclipse.core.resources.IFolder getContentFolder()

Returns the project folder the external content is stored in

Returns:
  the project folder the external content is stored in

#### getAdditionalRawEntries

    protected List<IPathEntry> getAdditionalRawEntries()

Get additional raw entries (above those added as part of the ExternalExportProjectProvider functionality)

Returns:
  a list of additional entries to add to the project

#### getLocationConverter

    public IIndexLocationConverter getLocationConverter(ICProject cproject)

Description copied from interface: `IExportProjectProvider`
The location converter to use on export. This converter will be called to convert IIndexFileLocation's to an external form. The external form is implementation dependent.

See Also:
  `URIRelativeLocationConverter`, `ResourceContainerRelativeLocationConverter`

#### getExportProperties

    public Map<String,String> getExportProperties()

Description copied from interface: `IExportProjectProvider`
Get a String to String map of properties to store with the index content. The export framework may ignore this if the index format does not support this. The PDOM format does support properties.

Returns:
  a Map of String typed key value pairs representing ISV specific properties. This may return null.